<?php
class Fasdab {
	function Fasdab($host, $username, $password, $database, $persistent = TRUE) {
		$function = ($persistent) ? 'pg_pconnect' : 'pg_connect';
		if (!$this->connection = $function("host='$host' user='$username' password='$password' dbname='$database'")) return FALSE;

		return TRUE;
	}



	function query($query, $key = 0) {
		$this->last_query = $query;
		return ($this->results[$key] = pg_exec($this->connection, $query)) ? TRUE : FALSE;
	}



	function debug() {
		return "<span style='white-space: pre; background: #000070; color: #ffffff; font: 0.8em sans-serif'>".htmlspecialchars($this->last_query)."</span><br/>\n";
	}



	function begin() {
		$this->query('BEGIN', count($this->results));
		$notice = pg_last_notice($this->connection);
		if ($notice[0] == 'N') {
			trigger_error($notice, E_USER_WARNING);
			return FALSE;
		}
		
		return TRUE;
	}



	function rollback() {
		$this->query('ROLLBACK', count($this->results));
		$notice = pg_last_notice($this->connection);
		if ($notice[0] == 'N') {
			trigger_error($notice, E_USER_WARNING);
			return FALSE;
		}
		
		return TRUE;
	}



	function commit() {
		$this->query('COMMIT', count($this->results));
		$notice = pg_last_notice($this->connection);
		if ($notice[0] == 'N') {
			trigger_error($notice, E_USER_WARNING);
			return FALSE;
		}
		
		return TRUE;
	}



	function cell($query) {
		$key = uniqid(0);

		$this->query($query, $key);
		return pg_result($this->results[$key], 0, 0);
	}



	function row($key = 0) {
		return pg_fetch_object($this->results[$key]);
	}



	function row_count() {
		$command = strtoupper(substr($this->last_query, 0, 6));
		$function = ($command == 'INSERT' || $command == 'UPDATE' || $command == 'DELETE') ? 'pg_cmdtuples' : 'pg_numrows';
		return $function(max($this->results));
	}



	function limit($rows, $offset = 0) {
		return "LIMIT $rows OFFSET $offset";
	}



	function last_id($table, $serial_column = 'id') {
		if (!$oid = pg_getlastoid(max($this->results))) return FALSE;
		return $this->cell("SELECT $serial_column FROM $table WHERE oid = $oid");
	}



	function serial() {
		return 'SERIAL';
	}



	function unix_timestamp($column) {
		return "EXTRACT(EPOCH FROM $column)";
	}
}
?>